
Type Explosion

    Field posX# 
    Field posY#
    Field frame
    Field timer

End Type



Function NewExplosion.Explosion (posX#, posY#)

    e.Explosion = New Explosion
    
    e\posX# = posX#
    e\posY# = posY#
    e\frame = 0
    e\timer = EXPLOSION_TIMER 
    
    Return e

End Function



Function UpdateExplosions ()

    For e.Explosion = Each Explosion
    
        If GAME\frame Mod 5 = 0 Then e\frame = 1 - e\frame
        e\timer = e\timer - 1
        If e\timer = 0 Then Delete e
    
    Next


End Function



Function CollisionExplosion ()

    gScore = 0

    grenadeKills = 0
    forceWilhelm = False 
    For e.Enemy = Each Enemy
    
        If ImagesCollide(IMG_GRENADE_COLLIDER, HERO\grenadeX#, HERO\grenadeY#, 0, IMG_ENEMY, e\posX#, e\posY#, e\frame)
        
            grenadeKills = grenadeKills + 1 
        
            NewCorpse(e)
            gScore = gScore + RegisterKill(e)
        
            If e\isBoss = True Then forceWilhelm = true
        
            Delete e
  
        End If 
    
    Next

    If grenadeKills = 0
        ResetKillStreak()
    Else
    
        If forceWilhelm = True Or Rand(1,8) = 1 Then PlaySoundWilhelm(HERO\grenadeX#)

        NewEnemyScore(HERO\grenadeX#, HERO\grenadeY#, gScore)
        
    End If

End Function 



Function RenderExplosions ()

    For e.Explosion = Each Explosion
    
        DrawImage(IMG_EXPLOSION, e\posX#, e\posY#, e\frame)
    
    Next

End Function




